<?php
//call the FPDF library
//require('fpdf181/fpdf.php');
$this->load->library('Fpdf_Master');

//$today = date('Y-m-d'));
//A4 width : 219mm
//default margin : 10mm each side
//writable horizontal : 219-(10*2)=189mm

//$tt =  $user;
//class PDF_sample extends FPDF

$data= '';   

class PDF_sample extends FPDF {
  
  	private $data = array();
  	private $inv = array();
  	private $inv_itm = array();
  	private $tm = array();
  	private $ret_itm = array();
  	private $options = array(
  		'inv' => '',
  		'destinationfile' => '',
  		'paper_size'=>'F4',
  		'orientation'=>'P'
  	);
  	
  	function __construct($data = array(), $options = array(),$inv = array(),$inv_itm = array(),$tm = array(),$ret_itm = array()) {
    	parent::__construct();
    	$this->data = $data;
    	$this->inv = $inv;
    	$this->inv_itm = $inv_itm;
    	$this->ret_itm = $ret_itm;
    	$this->options = $options;
    	$this->tm = $tm;
	}
	

	
	function Footer()
{
    // Go to 1.5 cm from bottom
   
    $this->SetY(-15);
    
//	$this->Image('assets/images/meslogo.png',8,10,-300);  //$this->Image('img/cargologo.jpg',15,890,40,40);
//	$this->Image('img/cargologo.jpg',15,540,50,50);
	 
	 //$this->Ln(2);
$this->SetFont('Arial','B',8);
//$this->Cell(5 ,-3,'CREATED USER & DATE : ' .$this->inv[0]->grn_cuser.' / '.$this->inv[0]->grn_cdate,0,0);//end of line
//$this->Cell(5 ,5,$this->inv[0]->grn_euser,0,0);//end of line

   $this->SetFont('Arial','',7);
	 
//	$this->SetX(0); $this->Cell(0, 10, $this->tm[1][0]->pro_fslogans, 0, 0,'C');
//	$this->Ln(2);
//	$this->SetX(0); $this->Cell(0, 12, $this->tm[1][0]->pro_sfslogans, 0, 0,'C');
    // Select Arial italic 8
    $this->SetFont('Arial','',7);
	
    // Print centered page number
    //$this->Cell(0,10,'Page '.$this->PageNo(),0,0,'R');
    $this->Cell(0,10,'Page '.$this->PageNo().' of {nb}',0,0,'R');
     $this->Line(18,283,205,283);
	
}
	
	public function rptDetailData () {
		
		//
		$border = 0;
		$this->AddPage();
		$this->SetAutoPageBreak(False);
		$this->SetAutoPageBreak(true, 15);
		$this->AliasNbPages();
		$left = 18;
		$left1 = 5;
		//$left = 15;
		
		
	$this->SetLeftMargin($left);


   


			$this->SetFont('Arial','B',12);	

$this->Cell(0 ,5,$this->tm[1]->pro_name ,0,1,'C');//end of line
$this->SetFont('Arial','',10);	
$this->Cell(0 ,5,$this->tm[1]->pro_add,0,1,'C');//end of line
	$this->SetFont('Arial','B',10);	
	if($this->inv['ref']=='0'){$ref = "All";}else{$ref = $this->inv['fullname'];}
	$this->Cell(0 ,5,'INVOICE PROFILE - From '.$this->inv['fdate'].' To '.$this->inv['todate'] .' | Rep - '.$ref ,0,1,'C');//end of line 
	$this->SetFont('Arial','',10);



	
	//end include

//set font to arial, regular, 12pt
$this->SetFont('Arial','B',10);


$this->Ln(4);
		
      //summary
      //$this->SetFont('Arial','B',9);
//$this->Cell(92 ,5,'',0,0);
//$this->Cell(73 ,5,'',0,0);
//$this->Cell(28 ,5,'',1,0);
//$this->Cell(22 ,5,number_format($invtotal,2),1,1,'R');//end of line  

		
		$h = 5;
		$left = 40;
		$top = 10;	
		#tableheader
		$this->SetFillColor(200,200,200);	
		$left = $this->GetX();
		$this->SetFont("Arial", "B", 8);
		$this->Cell(9,$h,'ID',1,0,'C',true);
		$this->SetX($left += 9); $this->Cell(22, $h, 'INVOICE', 1, 0, 'C',true);
		$this->SetX($left += 22); $this->Cell(75, $h, 'CUSTOMER', 1, 0, 'C',true);
		$this->SetX($left += 75); $this->Cell(10, $h, 'QTY', 1, 0, 'C',true);
		$this->SetX($left += 10); $this->Cell(20, $h, 'AMOUNT', 1, 0, 'C',true);
		$this->SetX($left += 20); $this->Cell(16, $h, 'PAYMENT', 1, 0, 'C',true);
		$this->SetX($left += 16); $this->Cell(20, $h, 'DATE', 1, 0, 'C',true);
		$this->SetX($left += 20); $this->Cell(15, $h, 'USER', 1, 1, 'C',true);
		//$this->SetX($left += 22); $this->Cell(22, $h, 'DISCOUNT', 1, 0, 'C',true);
		//$this->SetX($left += 22); $this->Cell(22, $h, 'NET TOTAL', 1, 1, 'C',true);		
		
	//	$this->SetX($left += 77); $this->Cell(28, $h, 'RATE('.$this->inv[0]->curr_symble.')', 1, 0, 'C',true);
	//	$this->SetX($left += 28); $this->Cell(28, $h, 'AMOUNT('.$this->inv[0]->curr_symble.')', 1, 1, 'C',true);

		//$this->Ln(20);
		
		$this->SetFont('Arial','',9);
		$this->SetWidths(array(9,22,75,10,20,16,20,15));
		$this->SetAligns(array('C','L','L','R','R','R','R','R'));
		//$this->SetFontStyle(array('B','B','B','B','B','B','B','B'));
		$no = 1; $this->SetFillColor(255);

		$i=0;
        $total=0;
        $itmcount=$total_val=0;
        
        
        
        foreach ($this->inv_itm as $post)   { 
            //if($post->serv_name!=""){$itm_name = $post->serv_name;
            //}else{$itm_name = $post->brand_name." ".$post->itm_name.$post->serv_name."\n".$post->part_no."\n".$post->model_name;}
            
            $this->Row(

            array($no++,
            $post[0],
            $post[1],
			$post[3],
			$post[4],
			$post[2],
			$post[6],
			$post[5]
			
		//	number_format(($post[4]),2,".",","),                                                                                        
           // number_format(($post[4] * $post[5]),2,".",",")
          ));
          
          $i= $i+1;
      $total = $total + $post[3] ;
       $total_val = $post[4]+$total_val;
          //  $itmcount = $itmcount+$post[4];
        }
        $invtotal =$INVi= "0";
 
 
 
        $this->Ln(5);
        
        
        
        $this->SetFont('Arial','B',12);	
	$this->Cell(140 ,5,'',0,1,'R');//end of line
	 $this->Ln(2);
	 $this->SetFont('Arial','',8);	
//summary
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'TOTAL QTY',0,0);
$this->Cell(28 ,5,'',0,0,'R');
$this->Cell(28 ,5,$total,1,1,'R');//end of line

$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'TOTAL VALUE',0,0);
$this->Cell(28 ,5,'',0,0,'R');
$this->Cell(28 ,5,number_format($total_val,2),1,1,'R');//end of line



//$dd = ($this->inv[0]->po_discount * 100)/$total;
//$dispre = number_format((float)$dd, 2, '.', '');

$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'DISCOUNT '.$dispre.'%',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($this->inv[0]->po_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line
//$divd = ($total-($this->inv[0]->po_discount));

//$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'NET TOTAL',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($total-$this->inv[0]->po_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line

//$divd = ($total-($this->inv[0]->po_discount));

//$taxspre = ($this->inv[0]->po_tax * $divd)/100 ;






//$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'TOTAL',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($this->inv[0]->po_final_tot,2),1,1,'R');//end of line

//$this->Ln(2);
//$this->SetFont('Arial','B',8);
//$this->Cell(12 ,5,'ITEMS: ',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
//$this->SetFont('Arial','',8);
//$this->Cell(10 ,5,$i,0,0);//end of line
//$this->SetFont('Arial','B',8);
//$this->Cell(19 ,5,'QUANTITY: ',0,0);//end of line
//$this->SetFont('Arial','',8);
//$this->Cell(10 ,5,$total,0,0);//end of line
//$this->SetFont('Arial','B',8);
//$this->Cell(19 ,5,'TOTAL VALUE: ',0,0);//end of line
//$this->SetFont('Arial','',8);
//$this->Cell(30 ,5,$total,0,1);//end of line
//$this->AliasNbPages();
//$this->AddPage();

//$this->Ln(2);
//$this->SetFont('Arial','B',8);
//$this->Cell(30 ,5,'RETURN REASON :',0,0);
//$this->SetFont('Arial','',8);
//$this->Cell(150 ,5,$this->inv[0]->ret_reason,0,1);
//end of line

//$this->Ln(3);
//$this->SetFont('Arial','',8);

//$this->Cell(150 ,5,'---------------------',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
//$this->Cell(30 ,5,'----------------------',0,1);//end of line
//$this->SetFont('Arial','B',8);
//$this->Cell(50 ,5,'TERMS & CONDITIONS :',0,1);//end of line
//$this->SetFont('Arial','',10);
//$this->Cell(150 ,5,"",0,0);//end of line



//$this->inv[0]->po_tc;
$this->SetFont('Arial','',9);
$this->Ln(15);
$this->Cell(80 ,5,'',0,0);//end of line
$this->Cell(70 ,5,'-------------------------',0,0);//end of line
$this->Cell(40 ,5,'-------------------------',0,1);//end of line

$this->Cell(80 ,2,'',0,0);//end of line
$this->Cell(70 ,2,'     Requested by',0,0);//end of line
$this->Cell(40 ,2,'    Authorized By',0,1);//end of line


//$this->Ln(5);
$this->SetFont('Arial','',8);


	}

	public function printPDF () {
				
	
		
	    $this->SetAutoPageBreak(false);
	    $this->AliasNbPages();
	    $this->SetFont("helvetica", "B", 10);
	    //$this->AddPage();
		
		
		
		
		
	    $this->rptDetailData();
			    
	    $this->Output();
  	}
  	
  	private $widths;
	private $aligns;

	function SetWidths($w)
	{
		//Set the array of column widths
		$this->widths=$w;
	}

	function SetAligns($a)
	{
		//Set the array of column alignments
		$this->aligns=$a;
	}

	function Row($data)
	{
		//Calculate the height of the row
		$nb=0;
		for($i=0;$i<count($data);$i++)
			$nb=max($nb,$this->NbLines($this->widths[$i],$data[$i]));
		$h=4*$nb;
		//Issue a page break first if needed
		$this->CheckPageBreak($h);
		//Draw the cells of the row
		for($i=0;$i<count($data);$i++)
		{
			$w=$this->widths[$i];
			$a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
			//Save the current position
			$x=$this->GetX();
			$y=$this->GetY();
			//Draw the border
			$this->Rect($x,$y,$w,$h);
			//Print the text
			$this->MultiCell($w,4,$data[$i],0,$a);
			//Put the position to the right of the cell
			$this->SetXY($x+$w,$y);
		}
		//Go to the next line
		$this->Ln($h);
	}

	function CheckPageBreak($h)
	{
		//If the height h would cause an overflow, add a new page immediately
		if($this->GetY()+$h>$this->PageBreakTrigger)
			
			$this->AddPage($this->CurOrientation);
	
	}

	function NbLines($w,$txt)
	{
		//Computes the number of lines a MultiCell of width w will take
		$cw=&$this->CurrentFont['cw'];
		if($w==0)
			$w=$this->w-$this->rMargin-$this->x;
		$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
		$s=str_replace("\r",'',$txt);
		$nb=strlen($s);
		if($nb>0 and $s[$nb-1]=="\n")
			$nb--;
		$sep=-1;
		$i=0;
		$j=0;
		$l=0;
		$nl=1;
		while($i<$nb)
		{
			$c=$s[$i];
			if($c=="\n")
			{
				$i++;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
				continue;
			}
			if($c==' ')
				$sep=$i;
			$l+=$cw[$c];
			if($l>$wmax)
			{
				if($sep==-1)
				{
					if($i==$j)
						$i++;
				}
				else
					$i=$sep+1;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
			}
			else
				$i++;
		}
		return $nl;
	}
} //end of class


$options = array(
	'inv' => $inv, //nama file penyimpanan, kosongkan jika output ke browser
	'destinationfile' => '', //I=inline browser (default), F=local file, D=download
	'paper_size'=>'F4',	//paper size: F4, A3, A4, A5, Letter, Legal
	'orientation'=>'P' //orientation: P=portrait, L=landscape

);

$tabel = new PDF_sample($data,$options,$inv,$inv_itm,$tm,$ret_itm);
//$tabel->printPDF();
$tabel->printPDF();
?>